<template>
  <div class="mod-config">
    <el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
      <el-form-item>
        <el-input v-model="dataForm.taskName" placeholder="任务名" clearable></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="getDataList()">查询</el-button>
        <el-button type="warning" @click="downUpHotel()">酒店上下架</el-button>
        <el-button type="warning" @click="delrp()">rp删除</el-button>
        <el-button v-if="isAuth('op:taskstatus:init')" type="warning" @click="initHotel()">酒店初始化</el-button>
        <el-button v-if="isAuth('op:taskstatus:delete')" type="danger" @click="deleteHandle()" :disabled="dataListSelections.length <= 0">批量删除</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      border
      v-loading="dataListLoading"
      @selection-change="selectionChangeHandle"
      style="width: 100%;">
      <el-table-column
        type="selection"
        header-align="center"
        align="center"
        width="50">
      </el-table-column>
      <el-table-column
        prop="id"
        header-align="center"
        align="center"
        label="id">
      </el-table-column>
      <el-table-column
        prop="taskName"
        header-align="center"
        align="center"
        label="任务名称">
      </el-table-column>
      <el-table-column
        prop="taskCode"
        header-align="center"
        align="center"
        label="任务编码">
      </el-table-column>
      <el-table-column
        prop="total"
        header-align="center"
        align="center"
        label="总数">
      </el-table-column>
      <el-table-column
        prop="completed"
        header-align="center"
        align="center"
        label="已完成数">
      </el-table-column>
      <el-table-column
        :formatter="tranCompPercent"
        prop="compPercent"
        header-align="center"
        align="center"
        label="完成百分比"
      ></el-table-column>
      <el-table-column
        prop="dtName"
        header-align="center"
        align="center"
        label="分销商名称">
      </el-table-column>
      <el-table-column
        prop="startTime"
        header-align="center"
        align="center"
        label="任务创建时间">
      </el-table-column>
      <el-table-column
        prop="endTime"
        header-align="center"
        align="center"
        label="完成任务时间">
      </el-table-column>
      <el-table-column
        fixed="right"
        header-align="center"
        align="center"
        width="150"
        label="操作">
        <template slot-scope="scope">
          <el-button type="text" size="small" @click="deleteHandle(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      @size-change="sizeChangeHandle"
      @current-change="currentChangeHandle"
      :current-page="pageIndex"
      :page-sizes="[10, 20, 50, 100]"
      :page-size="pageSize"
      :total="totalPage"
      layout="total, sizes, prev, pager, next, jumper">
    </el-pagination>
    <add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getDataList"></add-or-update>
    <delrp v-if="delrpVisible" ref="delrp" @refreshDataList="getDataList"></delrp>
  </div>
</template>


<script>
  import AddOrUpdate from './taskstatus-add-or-update'
  import Delrp from './taskstatus-delrp'
  export default {
    data () {
      return {
        dataForm: {
          key: '',
          taskName: ''
        },
        dataList: [],
        pageIndex: 1,
        pageSize: 10,
        totalPage: 0,
        dataListLoading: false,
        dataListSelections: [],
        addOrUpdateVisible: false,
        delrpVisible: false
      }
    },
    components: {
      AddOrUpdate,
      Delrp
    },
    activated () {
      this.getDataList()
    },
    methods: {
      // 酒店初始化
      initHotel () {
        this.$confirm(`是否确定执行`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          this.dataListLoading = true
          this.$http({
            url: this.$http.adornUrl('/op/taskstatus/init'),
            method: 'get'
          }).then(({data}) => {
            if (data && data.code === 0) {
              this.$message({
                message: data.msg,
                type: 'success',
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              })
            } else {
              this.$message.error(data.msg)
            }
            this.dataListLoading = false
          })
        })
      },
      delrp() {
        this.delrpVisible = true
        this.$nextTick(() => {
          this.$refs.delrp.init()
        })
      },
      downUpHotel() {
        this.addOrUpdateVisible = true
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(
          )
        })
      },
      // 完成百分比 completed已完成   total总数
      tranCompPercent(row, com) {
        let percent = ""
        if (row.completed === null || row.completed === undefined || row.completed === 0) {
          percent = 0 + "%"
        } else if (row.completed != null && row.completed !== undefined && row.completed !== 0) {
          let tem = (row.completed / row.total) * 100 + ""
          let re = /([0-9]+\.[0-9]{2})[0-9]*/
          percent = tem.replace(re, "$1") + "%"
        } else if (row.status === 1 || row.completed === 0) {
          percent = "100%"
        } else {
          let tem = (row.completed / row.total) * 100
          let re = /([0-9]+\.[0-9]{2})[0-9]*/ + ""
          percent = tem.replace(re, "$1") + "%"
        }
        return percent
      },
      // 获取数据列表
      getDataList () {
        this.dataListLoading = true
        this.$http({
          url: this.$http.adornUrl('/op/taskstatus/list'),
          method: 'get',
          params: this.$http.adornParams({
            'page': this.pageIndex,
            'limit': this.pageSize,
            'key': this.dataForm.key,
            'taskName': this.dataForm.taskName
          })
        }).then(({data}) => {
          if (data && data.code === 0) {
            this.dataList = data.page.list
            this.totalPage = data.page.totalCount
          } else {
            this.dataList = []
            this.totalPage = 0
          }
          this.dataListLoading = false
        })
      },
      // 每页数
      sizeChangeHandle (val) {
        this.pageSize = val
        this.pageIndex = 1
        this.getDataList()
      },
      // 当前页
      currentChangeHandle (val) {
        this.pageIndex = val
        this.getDataList()
      },
      // 多选
      selectionChangeHandle (val) {
        this.dataListSelections = val
      },
      // 删除
      deleteHandle (id) {
        var ids = id ? [id] : this.dataListSelections.map(item => {
          return item.id
        })
        this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '删除' : '批量删除'}]操作?`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          this.$http({
            url: this.$http.adornUrl('/op/taskstatus/delete'),
            method: 'post',
            data: this.$http.adornData(ids, false)
          }).then(({data}) => {
            if (data && data.code === 0) {
              this.$message({
                message: '操作成功',
                type: 'success',
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              })
            } else {
              this.$message.error(data.msg)
            }
          })
        })
      }
    }
  }
</script>
